proxy_cache_path  /app/cache  levels=1:2    keys_zone=panoramax:10m    inactive=24h  max_size=2g;


server {
    server_name localhost;
    listen <%= ENV['PORT'] %>;
    
    client_body_buffer_size 6M;

    location /api {
        proxy_pass <%= ENV["GEOVISIO_BACKEND"] %>;
        
        proxy_set_header X-Forwarded-Host $host;
        proxy_set_header X-Forwarded-For $proxy_add_x_forwarded_for;
        proxy_redirect default;
    }

    location ~ ^/api(/|/conformance/|/configuration/)$ {
        proxy_pass <%= ENV["GEOVISIO_BACKEND"] %>/api/$1;
        proxy_set_header X-Forwarded-Host $host;
        proxy_set_header X-Forwarded-For $proxy_add_x_forwarded_for;
        proxy_redirect <%= ENV["GEOVISIO_BACKEND"] %>/api/ /api/ ;

        # We change the CORS header, to put back the requested origin
        proxy_hide_header Access-Control-Allow-Origin;
        add_header Access-Control-Allow-Origin "$http_origin";

        proxy_cache            panoramax;
        proxy_cache_key $proxy_host$http_accept_encoding$uri$is_args$args;
        # use cache in case a backend dead
        add_header x-proxy-cache $upstream_cache_status;
        proxy_cache_valid     1h;
        proxy_cache_use_stale  error timeout invalid_header updating http_500 http_502 http_503 http_504;
    }
    location /api/docs {
        proxy_pass <%= ENV["GEOVISIO_BACKEND"] %>/api/docs;
        proxy_set_header X-Forwarded-Host $host;
        proxy_set_header X-Forwarded-For $proxy_add_x_forwarded_for;
        proxy_redirect default;
        
        proxy_hide_header Access-Control-Allow-Origin;
        add_header Access-Control-Allow-Origin "$http_origin";

        proxy_cache            panoramax;
        proxy_cache_key $proxy_host$http_accept_encoding$uri$is_args$args;
        # use cache in case a backend dead
        add_header x-proxy-cache $upstream_cache_status;
        proxy_cache_valid     1h;
        proxy_cache_use_stale  error timeout invalid_header updating http_500 http_502 http_503 http_504;
    }
    location ~ ^/api/map/([0-7]/.*) {
        proxy_pass <%= ENV["GEOVISIO_BACKEND"] %>/api/map/$1;
        proxy_set_header X-Forwarded-Host $host;
        proxy_set_header X-Forwarded-For $proxy_add_x_forwarded_for;
        proxy_redirect <%= ENV["GEOVISIO_BACKEND"] %>/api/ /api/ ;

        proxy_hide_header Access-Control-Allow-Origin;
        add_header Access-Control-Allow-Origin "$http_origin";

        proxy_cache            panoramax;
        proxy_cache_key $proxy_host$http_accept_encoding$uri$is_args$args;
        add_header x-proxy-cache $upstream_cache_status;
        proxy_cache_valid     1h;
        proxy_cache_use_stale  error timeout invalid_header updating http_500 http_502 http_503 http_504;
    }

    location ~ ^/api/map/([8-9]/.*) {
        proxy_pass <%= ENV["GEOVISIO_BACKEND"] %>/api/map/$1;
        proxy_set_header X-Forwarded-Host $host;
        proxy_set_header X-Forwarded-For $proxy_add_x_forwarded_for;
        proxy_redirect <%= ENV["GEOVISIO_BACKEND"] %>/api/ /api/ ;

        proxy_hide_header Access-Control-Allow-Origin;
        add_header Access-Control-Allow-Origin "$http_origin";

        proxy_cache            panoramax;
        proxy_cache_key $proxy_host$http_accept_encoding$uri$is_args$args;
        # use cache in case a backend dead
        add_header x-proxy-cache $upstream_cache_status;
        proxy_cache_valid     10m;
        proxy_cache_use_stale  error timeout invalid_header updating http_500 http_502 http_503 http_504;
    }

    location /api/ {
        proxy_pass <%= ENV["GEOVISIO_BACKEND"] %>;
        proxy_set_header X-Forwarded-Host $host;
        proxy_set_header X-Forwarded-For $proxy_add_x_forwarded_for;
        proxy_redirect default;
    }
    location /apidocs/ {
        proxy_pass <%= ENV["GEOVISIO_BACKEND"] %>/apidocs/;
        proxy_redirect default;
    }
    location /apidocs {
        proxy_pass <%= ENV["GEOVISIO_BACKEND"] %>/apidocs/;
        proxy_redirect default;
    }
    location /apispec_1.json {
        proxy_pass <%= ENV["GEOVISIO_BACKEND"] %>/apispec_1.json;
        proxy_redirect default;
    }

    # Keycloak handling
    location /oauth/ {
        proxy_pass <%= ENV["KEYCLOAK"] %>/;

        # increase buffer size for oauth cookie storage
        proxy_buffer_size 16k;
        proxy_busy_buffers_size 24k;
        proxy_buffers 64 4k;

        # add X-forward- headers for keycloak to know it's canonical host
        proxy_set_header X-Forwarded-For $proxy_add_x_forwarded_for;
        proxy_set_header X-Forwarded-Host $host;
        proxy_set_header X-Forwarded-Proto $scheme;

        proxy_redirect default;
    }

    location = /.well-known/assetlinks.json {
        alias /app/well-known/assetlinks.json;
    }

    location / {
        proxy_pass <%= ENV["GEOVISIO_FRONT"] %>;
        proxy_redirect default;
    }

}
